"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
function convertToDocgen(filePath, doc) {
    var components = doc.components;
    if (components.length === 0) {
        return {
            displayName: path.basename(filePath, path.extname(filePath)),
            description: '',
            props: {},
        };
    }
    var comp = components[0];
    if (!comp.propInterface) {
        console.warn('REACT-DOCGEN-TYPESCRIPT It seems that your props type is not exported. Add \'export\' keyword to your props definition.');
    }
    return {
        displayName: comp.name,
        description: comp.comment,
        props: comp.propInterface ? getProps(comp.propInterface) : {}
    };
}
exports.convertToDocgen = convertToDocgen;
function getProps(props) {
    return props.members.reduce(function (acc, i) {
        var item = {
            description: i.comment,
            type: { name: i.type },
            defaultValue: null,
            required: i.isRequired
        };
        if (i.values && i.values.length > 0) {
            item.description = item.description + ' (one of the following:' + i.values.join(',') + ')';
        }
        acc[i.name] = item;
        return acc;
    }, {});
}
//# sourceMappingURL=docgenConverter.js.map